VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsFishFace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' ----------------------------------------------------------------------------
'
' clsFishFace(FishFace.cls)                             Ulrich Mller 28.03.99
'                                                       Dell XPS P90     VB5/6
'                                                                und VB4-32/16
'                                                                        v3.11
' Programm-Funktionen fr das Fischertechnik-Interface (parallel/seriell)
'
' Zugriff auf das Interface ber einen COM-Port mit API-Funktionen
'               bzw. einen LPT-Port ber InOut32.DLL / InOut16.DLL
'
'  Motorausgnge : 1 - 4(8), Digitaleingnge : 1 - 8(16)
'                            AnalogEingnge : 0 - 1 (cAEX - cAEY)
'
' ACHTUNG : wenn Source mit VB6 gespeichert wird, kommt bei spterem Open
'           mit VB5 eine Fehlermeldung : Inkompatibel
'           es reicht die Zeilen vor diesem Programmkopf zu lschen
'
' ----------------------------------------------------------------------------

Option Explicit

#If VBVersion = 532 Then
  Public Event InputImpuls(InputNr%, ImpulsNr%)
  Public Event InterfaceStatus(Quelle%)
  Public Event PositionChange(PosistionListe)
#End If

Public MotCntl As clsMotorListe

#If Win32 Then
  Private Declare Function GetTickCount Lib "kernel32" () As Long
  Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliSeconds&)
#Else
  Private Declare Function GetTickCount Lib "User" () As Long
#End If

#If Win32 Then
' --- Deklarationen InOut32.DLL ----
  Private Declare Function Inp% Lib "InOut32.DLL" (ByVal Port%)
  Private Declare Sub Out Lib "InOut32.DLL" (ByVal Port%, ByVal Value%)
#Else
' --- Deklarationen InOut16.DLL ----
  Private Declare Function Inp% Lib "InOut16.DLL" (ByVal Port%)
  Private Declare Sub Out Lib "InOut16.DLL" (ByVal Port%, ByVal Value%)
#End If

#If Win32 Then
' --- COM-Port Declares 32bit ------------------------------------------
  Private Declare Function CloseHandle Lib "kernel32" _
   (ByVal hObject As Long) As Long
  Private Declare Function CreateFile Lib "kernel32" _
    Alias "CreateFileA" (ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, _
    ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
  Private Declare Function GetCommModemStatus Lib "kernel32" _
    (ByVal hFile As Long, lpModemStat As Long) As Long
  Private Declare Function GetCommProperties Lib "kernel32" _
    (ByVal hFile As Long, lpCommProp As COMMPROP) As Long
  Private Declare Function WriteFile Lib "kernel32" _
    (ByVal hFile As Long, ByVal lpBuffer As Any, _
    ByVal nNumberOfBytesToWrite As Long, _
    lpNumberOfBytesWritten As Long, lpOverlapped As OVERLAPPED) As Long
  Private Declare Function ReadFile Lib "kernel32" _
    (ByVal hFile As Long, ByVal lpBuffer As Any, _
    ByVal nNumberOfBytesToRead As Long, _
    lpNumberOfBytesRead As Long, lpOverlapped As OVERLAPPED) As Long
  Private Declare Function SetCommState Lib "kernel32" _
    (ByVal hCommDev As Long, lpDCB As dcbType) As Long
  Private Declare Function GetCommState Lib "kernel32" _
    (ByVal nCid As Long, lpDCB As dcbType) As Long
  Private Declare Function SetCommTimeouts Lib "kernel32" _
    (ByVal hFile As Long, lpCommTimeouts As COMMTIMEOUTS) As Long
  Private Declare Function GetCommTimeouts Lib "kernel32" _
    (ByVal hFile As Long, lpCommTimeouts As COMMTIMEOUTS) As Long
  Private Declare Function GetLastError Lib "kernel32" () As Long
  
  ' --- Konstanten dazu -----
  
  Private Const GENERIC_READ = &H80000000
  Private Const GENERIC_WRITE = &H40000000
  Private Const OPEN_EXISTING = 3
  Private Const FILE_FLAG_OVERLAPPED = &H40000000
  Private Const INVALID_HANDLE_VALUE = -1
  Private Const GMEM_FIXED = &H0
  Private Const ClassBufferSizes% = 1024
  
  Private Const NOPARITY = 0
  Private Const ODDPARITY = 1
  Private Const EVENPARITY = 2
  Private Const MARKPARITY = 3
  Private Const SPACEPARITY = 4
  Private Const ONESTOPBIT = 0
  Private Const ONE5STOPBITS = 1
  Private Const TWOSTOPBITS = 2
  
  ' --- Type-Declares und Variable ---
  
  Private Type dcbType    ' Win32API.TXT is incorrect here.
          DCBlength As Long
          BaudRate As Long
          Bits1 As Long
          wReserved As Integer
          XonLim As Integer
          XoffLim As Integer
          ByteSize As Byte
          Parity As Byte
          StopBits As Byte
          XonChar As Byte
          XoffChar As Byte
          ErrorChar As Byte
          EofChar As Byte
          EvtChar As Byte
          wReserved2 As Integer
  End Type
  
  Private Type COMMPROP
          wPacketLength As Integer
          wPacketVersion As Integer
          dwServiceMask As Long
          dwReserved1 As Long
          dwMaxTxQueue As Long
          dwMaxRxQueue As Long
          dwMaxBaud As Long
          dwProvSubType As Long
          dwProvCapabilities As Long
          dwSettableParams As Long
          dwSettableBaud As Long
          wSettableData As Integer
          wSettableStopParity As Integer
          dwCurrentTxQueue As Long
          dwCurrentRxQueue As Long
          dwProvSpec1 As Long
          dwProvSpec2 As Long
          wcProvChar(1) As Integer
  End Type
  
  Private Type COMMTIMEOUTS
          ReadIntervalTimeout As Long
          ReadTotalTimeoutMultiplier As Long
          ReadTotalTimeOutConstant As Long
          WriteTotalTimeoutMultiplier As Long
          WriteTotalTimeoutConstant As Long
  End Type
  
  Private Type OVERLAPPED
          Internal As Long
          InternalHigh As Long
          offset As Long
          OffsetHigh As Long
          hEvent As Long
  End Type
#Else

' --- COM-Port Declares 16bit --------------------
  Private Declare Function OpenComm Lib "User" _
    (ByVal lpComName$, ByVal wInQue%, ByVal wOutQue%) As Integer
  Private Declare Function CloseComm Lib "User" (ByVal nCid%) As Integer
  Private Declare Function GetCommError Lib "User" _
    (ByVal nCid%, lpStat As ComStat) As Integer
  Private Declare Function ReadComm Lib "User" _
    (ByVal nCid%, ByVal lpBuf$, ByVal nSize%) As Integer
  Private Declare Function WriteComm Lib "User" _
    (ByVal nCid%, ByVal lpBuf$, ByVal nSize%) As Integer
  Private Declare Function BuildCommDCB Lib "User" _
    (ByVal lpDef$, lpDCB As DCB) As Integer
  Private Declare Function GetCommState Lib "User" _
    (ByVal nCid%, lpDCB As DCB) As Integer
  Private Declare Function SetCommState Lib "User" _
    (lpDCB As DCB) As Integer
    
  Private Type DCB
    ID As Byte
    BaudRate As Integer
    ByteSize As Byte
    Parity As Byte
    StopBits As Byte
    RlsTimeout As Integer
    CtsTimeout As Integer
    DsrTimeout As Integer
    
    Bits1 As Byte
    Bits2 As Byte
    
    XonChar As Byte
    XoffChar As Byte
    XonLim As Integer
    XoffLim As Integer
    PeChar As Byte
    EofChar As Byte
    EvtChar As Byte
    TxDelay As Integer
  End Type
  
  Private Type ComStat
    Bits As Byte
    cbInQue As Integer
    cbOutQue As Integer
  End Type
  
  Private Const IE_BADID = (-1)         ' Invalid or unsupported ID
  Private Const IE_OPEN = (-2)          ' Device Already Open
  Private Const IE_NOPEN = (-3)         ' Device Not Open
  
#End If

#If VBVersion = 532 Then
  Public Enum ftiKonstanten
    ftiAus = 0
    ftiEin = 1
    ftiLinks = 1
    ftiRechts = 2
    ftiAEX = 0
    ftiAEY = 1
    ftiFehler = &HFFFF
    ftiDFehler = &HFFFF
    ftiAFehler = &HFFFE
  End Enum
#End If

Private bIStatus$, bIStatusEX$, bIStatusEY$
Private Const cRAus = 0, cRLinks = 1, cRRechts = 2
Private Const cAEX = 0, cAEY = 1
Private Const cIStatus = 193, cIStatusEX = 197, cIStatusEY = 201
Private MotorAus%(1 To 8), MotorLinks%(1 To 8), MotorRechts%(1 To 8)
Private EingabeMaske%(1 To 16)

Private IOModus%            ' --- aktueller I/O-Modus nach OpenInterface
Private Const cIOCOM = 1, cIOLPT = 2
Private AnzeigePanel As Boolean    ' --- Interface Panel wird nicht angezeigt

' --- Private Variable ----------------

#If Win32 Then
  Private comI As Long                    ' --- Handle fr COM-Port
  Private comIDCB As dcbType              ' --- DCB des COM-Ports
  Private comITimeOuts As COMMTIMEOUTS    ' --- Controlblock fr Timeouts
  Private comICommProp                    ' --- Communication Properties
  Private overL As OVERLAPPED
#Else
  Private comI As Integer
  Private comIDCB As DCB
#End If

Private ComName$                        ' --- Name des akt. Ports (COM1,LPT1 )
Private PortAdr%                        ' --- Aktuelle Port-Adresse
Private AnalogKonst%, OutputKonst%      ' --- Konstanten fr parallele Interf.

Private MotorStatus%, InputStatus%, AnalogXY%(0 To 1), MitEvents As Boolean
Private bNotHalt As Boolean, NotStatus%, bResetButton As Boolean
Private AbbruchZeit&, AbbruchDelta&
Private Bremsweg%
Public Property Get AnalogDelay() As Integer
Attribute AnalogDelay.VB_Description = "Konstante fr die Zhlzeit fr die Analogeingnge"

' --- Konstante fr die Zhlzeit fr die Analogeingnge ---
'     Bereich ca. 1 - 100, schnellere Rechner - grerer Wert
'     Default = 25 fr Pentium 90

  AnalogDelay = AnalogKonst

End Property

Public Property Let AnalogDelay(ByVal AK%)

' --- Konstante fr die Zhlzeit fr die Analogeingnge ---
'     Bereich ca. 1 - 100, schnellere Rechner - grerer Wert

  AnalogKonst = AK
  
End Property


Public Function ClearMotors() As Integer
Attribute ClearMotors.VB_Description = "Lscht alle Ausgnge gleichzeitig (z.B. alle Motoren aus)."

' --- Ausschalten aller Motoren ---

  MotorStatus = 0
  ClearMotors = GetInputs()
  
End Function


Public Function CloseInterface() As Boolean
Attribute CloseInterface.VB_Description = "Schlieen des benutzten ComPorts"

Dim res%

#If Win32 Then
  CloseHandle (comI)
#Else
  res = CloseComm(comI)
#End If
  ComName = ""
  CloseInterface = True
  
End Function


Private Function ComFehler(FehlerNr&) As Integer

'  MsgBox "Problem " & FehlerNr, vbExclamation, "fischertechnik Interface"
  ComFehler = ftiFehler
  
End Function


Public Function EmergencyStop(ByVal InputNr%) As Integer
Attribute EmergencyStop.VB_Description = "Bedingtes Anhalten des Programmablaufs und Zurcksetzen aller Ausgnge whrend des Programmhalts"

' --- Ausschalten der Motorausgnge, Warten auf Ende NotHalt ----
'     Fortsetzen mit altem Motorstatus, wenn InputNr oder NotHalt-Button

Dim ST%

  ST = GetInputs()
  If bNotHalt Or (ST And EingabeMaske(InputNr)) Then
    NotStatus = MotorStatus
    ClearMotors
    Do
      ST = GetInputs()
    Loop While bNotHalt Or (ST And EingabeMaske(InputNr))
    bNotHalt = False
    ST = SetMotors(NotStatus)
    NotStatus = 0
  End If
  EmergencyStop = ST
  
End Function

Public Function GetAnalog(ByVal AnalogNr%) As Integer
Attribute GetAnalog.VB_Description = "Abfrage eines der beiden Analogeingnge"

' --- Abfrage eines der beiden Analogeingnge ---
'     Aufruf der portspezifischen Funktion

  If IOModus = cIOCOM Then
    GetAnalog = GetAnalogCOM(AnalogNr)
  Else
    GetAnalog = GetAnalogLPT(AnalogNr)
  End If
  
End Function
Private Function GetAnalogCOM(ByVal AnalogNr%) As Integer

' --- Abfrage eines der beiden Analogeingnge ---

Dim res&, w&, wrk$, AnalogWert&, n%

' --- Schreiben des Motorstatus und Abfrage eines der beiden
'     Analogeingnge
'     , String, Stringlnge, tatschliche Bytes, nicht overlapped

  wrk = "   "
  n = IIf(MotorStatus > 255 Or MotorStatus < 0, 0, MotorStatus)
  If AnalogNr = cAEX Then
#If Win32 Then
    res = WriteFile(comI, bIStatusEX & Chr$(n), 2, w, overL)
#Else
    res = WriteComm(comI, bIStatusEX & Chr(n), 2)
#End If
  Else
#If Win32 Then
    res = WriteFile(comI, bIStatusEY & Chr$(n), 2, w, overL)
#Else
    res = WriteComm(comI, bIStatusEY & Chr$(n), 2)
#End If
  End If
  
#If Win32 Then
  res = ReadFile(comI, wrk, 3, w, overL)
#Else
  n = OutputKonst
  Do
    w = ReadComm(comI, wrk, 3)
    n = n - 1
  Loop Until w >= 3 Or n < 0
#End If
  
  If w < 3 Then
    GetAnalogCOM = ftiDFehler
    If MitEvents Then DoEvents
   Else
    AnalogWert = (Asc(Mid(wrk, 2, 1)) * 256&) + Asc(Right(wrk, 1))
#If Win32 Then
    If AnalogWert < 0 Or AnalogWert > 1024 Then AnalogWert = 1024
#Else
    AnalogWert = AnalogWert / AnalogKonst
#End If
    GetAnalogCOM = AnalogWert
    AnalogXY(AnalogNr) = AnalogWert
    If MitEvents Then DoEvents
  End If
  
End Function
Private Function GetAnalogLPT(ByVal AnalogNr%) As Integer

' --- Abfrage eines der beiden Analogeingnge ---
'     liefert keinen Fehler

Dim AnalogWert%, i%, j%

On Error GoTo AnalogFehler

  AnalogWert = 0
  If AnalogNr = cAEX Then
      For j = 1 To OutputKonst
        Out PortAdr, &HA0                   ' --- Trigger X
      Next j
  Else
      For j = 1 To OutputKonst
        Out PortAdr, &H90                   ' --- Trigger Y
      Next j
  End If
  
  For j = 1 To OutputKonst
    Out PortAdr, &H38                       ' --- CLOCK
  Next j
  
  i = 0
  Do
    i = i + 1
    If i = AnalogKonst Then
      AnalogWert = AnalogWert + 1               ' --- Loop bei &HF8
      i = 0
    End If
  Loop While (Inp(PortAdr + 1) And &H80) > 1    ' --- Ende bei &H78
    
  AnalogXY(AnalogNr) = AnalogWert
  GetAnalogLPT = AnalogXY(AnalogNr)
  If MitEvents Then DoEvents
  Exit Function
  
AnalogFehler:
  GetAnalogLPT = ftiDFehler
  If MitEvents Then DoEvents
  
End Function



Public Function GetInput(ByVal InputNr%) As Boolean
Attribute GetInput.VB_Description = "Auslesen des Status des Einganges InputNr (1 - 8)"

' --- Refresh des MotorStatus, InputStatus und Abfrage Eingang(InputNr) ---

Dim res%

  res = GetInputs()
  GetInput = res And EingabeMaske(InputNr)
  
End Function


Public Function GetInputs() As Integer
Attribute GetInputs.VB_Description = "Refresh des Motorstatus und Abfrage des Eingabestatus"

' --- Refresh des Motorstatus und Abfrage des Eingabestatus ---
'     Aufruf der portspezifischen Funktion

Dim res%

  If IOModus = cIOCOM Then
    res = GetInputsCOM()
  Else
    res = GetInputsLPT()
  End If
  GetInputs = res
  
  If MitEvents Then DoEvents

#If VBVersion = 532 Then
  If MitEvents Then RaiseEvent InterfaceStatus(res)
#End If
  
End Function
Private Function GetInputsCOM() As Integer

' --- Refresh des Motorstatus und Abfrage des EingabeStatus ---

Dim res&, w&, wrk$, n%

  wrk = " "
  
' --- Schreiben aktuellen Motorstatus und warten auf Antwort :
'     Eingangsstatus
  
  n = IIf(MotorStatus > 255 Or MotorStatus < 0, 0, MotorStatus)

#If Win32 Then
' --- 32bit ----
'     , String, Stringlnge, tatschliche Bytes, nicht overlapped
  res = WriteFile(comI, bIStatus & Chr$(n), 2, w, overL)
  res = ReadFile(comI, wrk, 1, w, overL)
#Else
  res = WriteComm(comI, bIStatus & Chr$(n), 2)
  n = OutputKonst
  Do
    w = ReadComm(comI, wrk, 1)
    n = n - 1
  Loop Until w >= 1 Or n < 0
#End If
  
  If w < 1 Then
    GetInputsCOM = ftiFehler
  Else
    InputStatus = Asc(wrk)
    GetInputsCOM = InputStatus
  End If

End Function


Private Function GetInputsLPT() As Integer

' --- Abfrage des EingabeStatus ---
  
Dim res%, i%, j%

  For i = 16 To 1 Step -1
    If (MotorStatus And EingabeMaske(i)) <= 0 Then
      For j = 1 To OutputKonst
        Out PortAdr, &H30               ' --- 0     ( & Trigger )
      Next j
      For j = 1 To OutputKonst
        Out PortAdr, &H38               ' --- CLOCK ( & Trigger )
      Next j
    Else
      For j = 1 To OutputKonst
        Out PortAdr, &H34               ' --- DATA-OUT ( & Trigger )
      Next j
      For j = 1 To OutputKonst
        Out PortAdr, &H3C               ' --- DATA-OUT, CLOCK (&Trigger)
      Next j
    End If
  Next i
  For j = 1 To OutputKonst
    Out PortAdr, &H39                   ' --- LOAD-OUT, CLOCK (&Trigger)
  Next j

' -- Lesen Inputstatus, paralleles Interface ---

  InputStatus = 0
  For j = 1 To OutputKonst
    Out PortAdr, &H32         ' --- LOAD-IN
  Next j
  For j = 1 To OutputKonst
    Out PortAdr, &H3A         ' --- LOAD-IN & CLOCK
  Next j

  For i = 8 To 1 Step -1
    If (Inp(PortAdr + 1) And &H80) > 1 Then InputStatus = InputStatus Or EingabeMaske(i)
    For j = 1 To OutputKonst
      Out PortAdr, &H30        ' --- null
    Next j
    For j = 1 To OutputKonst
      Out PortAdr, &H38        ' --- CLOCK
    Next j
  Next i
  
  For i = 16 To 9 Step -1
    If (Inp(PortAdr + 1) And &H80) > 1 Then InputStatus = InputStatus Or EingabeMaske(i)
      For j = 1 To OutputKonst
        Out PortAdr, &H30        ' --- null
      Next j
      For j = 1 To OutputKonst
        Out PortAdr, &H38        ' --- CLOCK
      Next j
  Next i
      
  GetInputsLPT = InputStatus
  
End Function

Private Sub InitWerte()

  bIStatus = Chr$(cIStatus)
  bIStatusEX = Chr$(cIStatusEX)
  bIStatusEY = Chr$(cIStatusEY)
  
  MotorAus(1) = &HFFFC
  MotorAus(2) = &HFFF3
  MotorAus(3) = &HFFCF
  MotorAus(4) = &HFF3F
  MotorAus(5) = &HFCFF
  MotorAus(6) = &HF3FF
  MotorAus(7) = &HCFFF
  MotorAus(8) = &H3FFF
  
  MotorLinks(1) = &H1
  MotorLinks(2) = &H4
  MotorLinks(3) = &H10
  MotorLinks(4) = &H40
  MotorLinks(5) = &H100
  MotorLinks(6) = &H400
  MotorLinks(7) = &H1000
  MotorLinks(8) = &H4000
  
  MotorRechts(1) = &H2
  MotorRechts(2) = &H8
  MotorRechts(3) = &H20
  MotorRechts(4) = &H80
  MotorRechts(5) = &H200
  MotorRechts(6) = &H800
  MotorRechts(7) = &H2000
  MotorRechts(8) = &H8000
  
  EingabeMaske(1) = &H1
  EingabeMaske(2) = &H2
  EingabeMaske(3) = &H4
  EingabeMaske(4) = &H8
  EingabeMaske(5) = &H10
  EingabeMaske(6) = &H20
  EingabeMaske(7) = &H40
  EingabeMaske(8) = &H80
  EingabeMaske(9) = &H100
  EingabeMaske(10) = &H200
  EingabeMaske(11) = &H400
  EingabeMaske(12) = &H800
  EingabeMaske(13) = &H1000
  EingabeMaske(14) = &H2000
  EingabeMaske(15) = &H4000
  EingabeMaske(16) = &H8000
  
  bNotHalt = False
  NotStatus = 0
  AnzeigePanel = False
  MitEvents = True
  
#If Win32 Then
  comITimeOuts.ReadIntervalTimeout = 5
  comITimeOuts.ReadTotalTimeoutMultiplier = 4
  comITimeOuts.ReadTotalTimeOutConstant = 30
  comITimeOuts.WriteTotalTimeoutMultiplier = 1
  comITimeOuts.WriteTotalTimeoutConstant = 10
#End If

  AnalogKonst = 25
  OutputKonst = 3
  PortAdr = &H378
  AbbruchDelta = 800
  
End Sub

Public Property Let InterruptEnabled(ByVal w As Boolean)

' --- Setzen Interruptmodus ---------

  MitEvents = w
  
End Property

Public Property Get InterruptEnabled() As Boolean

' --- Status der Unterbrechungssteuerung (DoEvents in GetInputs ... )

  InterruptEnabled = MitEvents
  
End Property


Public Property Get LPTIOADR() As Integer

  LPTIOADR = PortAdr
  
End Property

Public Property Let LPTIOADR(PA%)

  PortAdr = PA
  
End Property

Public Function MoveDelta(ParamArray M())
Attribute MoveDelta.VB_Description = "Fahrauftrag fr mehrere Motoren, relative Positionierung"

' --- Verfahren der Motoren um die in M() angegebene Strecke ---

Dim anzMot%

  anzMot = UBound(M) + 1
  
  Select Case anzMot
  Case 1
    MoveDelta = MoveTo(MotCntl.Position(1) + M(0))
  Case 2
    MoveDelta = MoveTo(MotCntl.Position(1) + M(0), MotCntl.Position(2) + M(1))
  Case 3
    MoveDelta = MoveTo(MotCntl.Position(1) + M(0), MotCntl.Position(2) + M(1), MotCntl.Position(3) + M(2))
  Case 4
    MoveDelta = MoveTo(MotCntl.Position(1) + M(0), MotCntl.Position(2) + M(1), MotCntl.Position(3) + M(2), MotCntl.Position(4) + M(3))
  Case 5
    MoveDelta = MoveTo(MotCntl.Position(1) + M(0), MotCntl.Position(2) + M(1), MotCntl.Position(3) + M(2), MotCntl.Position(4) + M(3), MotCntl.Position(5) + M(4))
  Case 6
    MoveDelta = MoveTo(MotCntl.Position(1) + M(0), MotCntl.Position(2) + M(1), MotCntl.Position(3) + M(2), MotCntl.Position(4) + M(3), MotCntl.Position(5) + M(4), MotCntl.Position(6) + M(5))
  Case 7
    MoveDelta = MoveTo(MotCntl.Position(1) + M(0), MotCntl.Position(2) + M(1), MotCntl.Position(3) + M(2), MotCntl.Position(4) + M(3), MotCntl.Position(5) + M(4), MotCntl.Position(6) + M(5), MotCntl.Position(7) + M(6))
  Case 8
    MoveDelta = MoveTo(MotCntl.Position(1) + M(0), MotCntl.Position(2) + M(1), MotCntl.Position(3) + M(2), MotCntl.Position(4) + M(3), MotCntl.Position(5) + M(4), MotCntl.Position(6) + M(5), MotCntl.Position(7) + M(6), MotCntl.Position(8) + M(7))
  End Select
  
End Function

Public Function MoveTo(ParamArray Mpos())
Attribute MoveTo.VB_Description = "Fahrauftrag fr mehrere Motoren, absolute Positionierung"

' --- Fahren der Motoren zu der in M() angegebenen Position ---

Dim MotDreh%, MotAus%, MotEnde%, anzMot%, MotNr%, i%, res&
Dim StatusAlt%, StatusNeu%, StatusDelta%, MaskeEingnge%
Dim PositionListe As Variant
Dim M%(1 To 8), BremsPhase%(1 To 8), Bremse(1 To 8) As Boolean

On Error GoTo MoveToFehler

  anzMot = UBound(Mpos) + 1
  MaskeEingnge = 0
  MotDreh = MotorStatus
  MotAus = MotorStatus
  PositionListe = Array()
  ReDim PositionListe(1 To anzMot)
  
  StatusNeu = GetInputs()
  
' --- Fahrauftrag und Masken bestimmen ---
  
  For i = 1 To anzMot
    M(i) = Mpos(i - 1)
    MotNr = MotCntl.Nr(i)
    MotDreh = MotDreh And MotorAus(MotNr)   ' --- Einzelmotor Aus
    MotAus = MotAus And MotorAus(MotNr)     ' --- Zusammenstellen Motoren Aus
    Bremse(i) = False
    
'   Zusammenstellen der Schalteingnge
    MaskeEingnge = MaskeEingnge Or EingabeMaske(MotCntl.Impuls(i)) Or EingabeMaske(Abs(MotCntl.Ende(i)))

'   Fahrauftrag fr Einzelmotor
  
    If M(i) > MotCntl.Position(i) Then        ' --- weg von Endtaster
      If M(i) >= MotCntl.EndPosition(i) Then M(i) = MotCntl.EndPosition(i)
      If M(i) <= MotCntl.EndPosition(i) Then
        MotDreh = IIf(MotCntl.Ende(i) > 0, MotDreh Or MotorLinks(MotNr), MotDreh Or MotorRechts(MotNr))
        BremsPhase(i) = M(i) - Bremsweg
      End If
    End If
    If StatusNeu And EingabeMaske(Abs(MotCntl.Ende(i))) Then   ' --- zum Endtaster
      MotCntl.Position(i) = 0       ' --- steht auf Endtaster
    Else
      If M(i) <= 0 And MotCntl.Position(i) > 0 Then M(i) = -999
      If M(i) < MotCntl.Position(i) Then
        MotDreh = IIf(MotCntl.Ende(i) > 0, MotDreh Or MotorRechts(MotNr), MotDreh Or MotorLinks(MotNr))
        BremsPhase(i) = M(i) + Bremsweg
      End If
    End If
  Next i
  MotEnde = MotDreh
  
' --- Motoren starten, Ausgangsstatus merken ---

  StatusAlt = SetMotors(MotDreh) And MaskeEingnge
  AbbruchZeit = GetTickCount() + AbbruchDelta
  
' --- Schleife bis Fahrauftrag erledigt ---

  Do Until MotEnde = MotAus
    If bNotHalt Or GetTickCount() > AbbruchZeit Then
      res = ftiFehler
      Exit Do
    End If
    
'   --- Fahrauftrge und Status aktualisieren ---

    res = SetMotors(MotDreh)
    If res = ftiFehler Then Exit Do
    StatusNeu = res And MaskeEingnge
    StatusDelta = StatusAlt Xor StatusNeu
    StatusAlt = StatusNeu
    
'   --- Bearbeiten der Vernderungen ---

      For i = 1 To anzMot
        MotNr = MotCntl.Nr(i)
        
        If MotCntl.Ende(i) > 0 Then             ' --- Ende : Rechtsdrehend
          If MotEnde And MotorLinks(MotNr) Then
  
  ' ---     Impuls Drehrichtung links zhlen
            If StatusDelta And EingabeMaske(MotCntl.Impuls(i)) Then
              MotCntl.Position(i) = MotCntl.Position(i) + 1
              AbbruchZeit = GetTickCount() + AbbruchDelta
            End If
  ' ---     Bremsen
            If MotCntl.Position(i) >= BremsPhase(i) Then
              If Bremse(i) Then
                MotDreh = MotDreh Or MotorLinks(MotNr)
                Bremse(i) = False
              Else
                MotDreh = MotDreh And MotorAus(MotNr)
                Bremse(i) = True
              End If
            End If

  ' ---     Abschalten, wenn Position erreicht
            If MotCntl.Position(i) >= M(i) Then
              MotDreh = MotDreh And MotorAus(MotNr)
              MotEnde = MotDreh
            End If
            If MotCntl.Position(i) >= MotCntl.EndPosition(i) Then
              MotCntl.Position(i) = MotCntl.EndPosition(i)
              MotDreh = MotDreh And MotorAus(MotNr)
              MotEnde = MotDreh
            End If
          
          ElseIf MotEnde And MotorRechts(MotNr) Then
  
  ' ---     Impuls Drehrichtung rechts zhlen
            If StatusDelta And EingabeMaske(MotCntl.Impuls(i)) Then
              MotCntl.Position(i) = MotCntl.Position(i) - 1
              AbbruchZeit = GetTickCount() + AbbruchDelta
            End If
  ' ---     Bremsen
            If MotCntl.Position(i) <= BremsPhase(i) Then
              If Bremse(i) Then
                MotDreh = MotDreh Or MotorRechts(MotNr)
                Bremse(i) = False
              Else
                MotDreh = MotDreh And MotorAus(MotNr)
                Bremse(i) = True
              End If
            End If
  ' ---     Abschalten und Normieren, wenn Position erreicht oder Endschalter
            If MotCntl.Position(i) <= M(i) Then
              MotDreh = MotDreh And MotorAus(MotNr)
              MotEnde = MotDreh
            End If
            If StatusNeu And EingabeMaske(MotCntl.Ende(i)) Then
              MotCntl.Position(i) = 0
              MotDreh = MotDreh And MotorAus(MotNr)
              MotEnde = MotDreh
            End If
          End If
        Else                                   ' --- Ende : Linksdrehend
          If MotEnde And MotorRechts(MotNr) Then
  
  ' ---     Impuls Drehrichtung rechts zhlen
            If StatusDelta And EingabeMaske(MotCntl.Impuls(i)) Then
              MotCntl.Position(i) = MotCntl.Position(i) + 1
              AbbruchZeit = GetTickCount() + AbbruchDelta
            End If
  ' ---     Bremsen
            If MotCntl.Position(i) >= BremsPhase(i) Then
              If Bremse(i) Then
                MotDreh = MotDreh Or MotorRechts(MotNr)
                Bremse(i) = False
              Else
                MotDreh = MotDreh And MotorAus(MotNr)
                Bremse(i) = True
              End If
            End If
  ' ---     Abschalten, wenn Position erreicht
            If MotCntl.Position(i) >= M(i) Then
              MotDreh = MotDreh And MotorAus(MotNr)
              MotEnde = MotDreh
            End If
            If MotCntl.Position(i) >= MotCntl.EndPosition(i) Then
              MotCntl.Position(i) = MotCntl.EndPosition(i)
              MotDreh = MotDreh And MotorAus(MotNr)
              MotEnde = MotDreh
            End If
          
          ElseIf MotEnde And MotorLinks(MotNr) Then
  
  ' ---     Impuls Drehrichtung links zhlen
            If StatusDelta And EingabeMaske(MotCntl.Impuls(i)) Then
              MotCntl.Position(i) = MotCntl.Position(i) - 1
              AbbruchZeit = GetTickCount() + AbbruchDelta
            End If
  ' ---     Bremsen
            If MotCntl.Position(i) <= BremsPhase(i) Then
              If Bremse(i) Then
                MotDreh = MotDreh Or MotorLinks(MotNr)
                Bremse(i) = False
              Else
                MotDreh = MotDreh And MotorAus(MotNr)
                Bremse(i) = True
              End If
            End If
  ' ---     Abschalten und Normieren, wenn Position erreicht oder Endschalter
            If MotCntl.Position(i) <= M(i) Then
              MotDreh = MotDreh And MotorAus(MotNr)
              MotEnde = MotDreh
            End If
            If StatusNeu And EingabeMaske(Abs(MotCntl.Ende(i))) Then
              MotCntl.Position(i) = 0
              MotDreh = MotDreh And MotorAus(MotNr)
              MotEnde = MotDreh
            End If
          End If
        End If
      Next i
      
 '   --- RaiseEvent : MotorPositionen ---
    
     For i = 1 To anzMot
       PositionListe(i) = MotCntl.Position(i)
     Next i
#If VBVersion = 532 Then
     If MitEvents Then RaiseEvent PositionChange(PositionListe)
#End If
   
  Loop
  
' --- Motoren abschalten ---

  SetMotors MotAus
  If res = ftiFehler Then MoveTo = ftiFehler Else MoveTo = InputStatus
  Exit Function
  
MoveToFehler:
  MsgBox Err.Description & " : " & Err.Number, vbOKOnly, "fischertechnik Interface"
  MoveTo = ftiFehler
  
End Function

Public Property Get NotHalt() As Boolean
Attribute NotHalt.VB_Description = "Setzten/Abfragen des Status NotHalt (zur stuerung von EmergencyStop"

  NotHalt = bNotHalt
  
End Property

Public Property Let NotHalt(b As Boolean)

  bNotHalt = b
  
End Property


Public Function OpenInterface(PortName$, Optional ByVal ShowPanel, Optional ByVal WEvents) As Integer

' --- Initialisieren des Interface ---
'     Auffruf der portspezifischen Routinen

Dim PortNr%

  If IsMissing(ShowPanel) Then ShowPanel = False
  If Not IsMissing(WEvents) Then MitEvents = WEvents
  
  ComName = UCase(PortName)
  PortNr = Val(Right(ComName, 1))
  If PortNr < 0 Or PortNr > 8 Then PortNr = 1
  
  ChDir App.Path           ' --- ermglicht plazieren von FISCH32.DLL
  ChDrive App.Path         '     im App.Path
  
  If Left(ComName, 3) = "COM" Then
    IOModus = cIOCOM
    Bremsweg = 3
    OpenInterface = OpenInterfaceCOM(PortNr)
  Else
    IOModus = cIOLPT
    Bremsweg = -1
    OpenInterface = OpenInterfaceLPT(PortNr)
  End If
  
  If ShowPanel And InputStatus <> ftiDFehler Then
    AnzeigePanel = True
    Me.ShowPanel
  End If
  
  End Function


Private Function OpenInterfaceCOM(PortNr%) As Integer

' --- Initialisieren des Interface, Open ComPort ---

Dim res&

  If OutputKonst <= 0 Then OutputKonst = 2000
  
' --- Anlegen eines ComPort-Files --------------

#If Win32 Then
' --- 32bit
'     Lesen und Schreiben zulssig, exklusiv, keine Security,
'     mu vorh. sein, normale Attribute (kein Overlapp),kein Tempfile

  overL.hEvent = 0
  overL.offset = 0
  overL.OffsetHigh = 0
  
  comI = CreateFile(ComName, GENERIC_READ Or GENERIC_WRITE, 0, 0, _
    OPEN_EXISTING, 0&, 0)
  If comI = INVALID_HANDLE_VALUE Then
    InputStatus = ComFehler(comI)
    OpenInterfaceCOM = InputStatus
    Exit Function
  End If
  
' --- ModemSettings ----

  res = GetCommState(comI, comIDCB)
  
  comIDCB.BaudRate = 9600
  comIDCB.ByteSize = 8
  comIDCB.Parity = NOPARITY
  comIDCB.StopBits = ONESTOPBIT
  
  res = SetCommState(comI, comIDCB)
  
' --- TimeOuts einstellen : pro gelesenes Byte 4 ms + 30 ms gesamt ---

  res = SetCommTimeouts(comI, comITimeOuts)
#Else
  comI = OpenComm(ComName, 128, 128)
  If comI < 0 Then
    InputStatus = ComFehler((comI))
    OpenInterfaceCOM = InputStatus
    Exit Function
  End If
  res = BuildCommDCB(ComName & ":9600,n,8,1", comIDCB)
  res = SetCommState(comIDCB)
#End If

  InputStatus = GetInputsCOM()
  If InputStatus = ftiDFehler Then CloseInterface
  OpenInterfaceCOM = InputStatus
  
End Function


Private Function OpenInterfaceLPT(PortNr%) As Integer

' --- Initialisieren des Interface ---
'     ohne die Fehlerabfrage der seriellen Variante

Dim res&
  
  If OutputKonst <= 0 Then OutputKonst = 100
  
' --- Anlegen eines ComPort-Files --------------
'     Lesen und Schreiben zulssig, exklusiv, keine Security,
'     mu vorh. sein, normale Attribute (kein Overlapp),kein Tempfile

#If Win32 Then
  If ComName <> "LPT0" Then    ' --- kein Open, wenn Sonderadresse
                               '     ber Eigenschaft LPTIOADR und
                               '     PortName = LPT0
    comI = CreateFile(ComName, GENERIC_READ Or GENERIC_WRITE, 0, 0, _
      OPEN_EXISTING, 0&, 0)
    If comI = INVALID_HANDLE_VALUE Then
      InputStatus = ComFehler(comI)
      OpenInterfaceLPT = InputStatus
      Exit Function
    End If
  End If
#End If
  
  Select Case PortNr
  Case 1
  PortAdr = &H378
  Case 2
    PortAdr = &H278
  Case 3
    PortAdr = &H3BC
  Case Else             ' --- Bei LPT0 und PortNr = 0 bleibt Wert PortAdr
                        '     erhalten (Eigenschaft LPTIOADR)
  End Select
  
  res = GetInputsLPT()
  res = GetAnalogLPT(0)
  If res = ftiDFehler Then
    CloseInterface
    OpenInterfaceLPT = ftiDFehler
  Else
    OpenInterfaceLPT = GetInputsLPT()
  End If
  
End Function

  
Public Property Get OutputDelay() As Integer
Attribute OutputDelay.VB_Description = "Konstante fr die Ausgabe Verzgerung "

' --- Konstante fr die Ausgabe Verzgerung (bei schnellen Rechnern) ---
'     Bereich ca. 50 - 1000, schnellere Rechner - grerer Wert
'     Default = 100 fr Pentium 90
'     fr paralleles und serielles Interface (16bit)

  OutputDelay = OutputKonst
  
End Property


Public Property Let OutputDelay(OK%)

' --- Konstante fr die Ausgabe Verzgerung (bei schnellen Rechnern ---
'     Bereich ca. 50 - 1000, schnellere Rechner - grerer Wert
'     fr paralleles und serielles Interface (16bit)

  OutputKonst = OK
  
End Property

#If VBVersion = 532 Then
Friend Property Let PanelEnabled(w As Boolean)

  AnzeigePanel = w
  
End Property
#End If

Public Property Get PanelEnabled() As Boolean

  PanelEnabled = AnzeigePanel
  
End Property


Public Property Get PortName() As String
Attribute PortName.VB_Description = "Name des aktuell geffneten Ports"

' --- Name des aktuell geffneten Ports ---

  PortName = ComName
  
End Property

Public Property Get Reset() As Boolean
Attribute Reset.VB_Description = "Setzten/Abfragen des Status Reset (zur Stuerung von Reset)"

  Reset = bResetButton
  
End Property

Public Property Let Reset(r As Boolean)

  bResetButton = r
  
End Property

Public Function ResetMotors(ByVal InputNr%) As Boolean
Attribute ResetMotors.VB_Description = "Bedingtes Zurcksetzten aller Ausgnge. Erfolgt, wenn der angegebene Eingang oder die Eingenschaft Reset wahr sind"

' --- Ausschalten der Motorausgnge, wenn InputNr oder ResetButton ---

  If GetInput(InputNr) Or bResetButton Then
    ClearMotors
    ResetMotors = True
  Else
    ResetMotors = False
  End If
  
End Function

Public Function SetMotor(ByVal MotorNr%, ByVal Direction%) As Integer
Attribute SetMotor.VB_Description = "Steuern eines einzelnen Ausganges 1-4 (Motor, Lampe ...)"

' --- Schalten eines ausgewhlten Motors ---

' MotorStatus auf Motor aus setzen -----
  MotorStatus = MotorStatus And MotorAus(MotorNr)
  Select Case Direction
  Case cRLinks                     ' --- Motor Linkslauf
    MotorStatus = MotorStatus Or MotorLinks(MotorNr)
  Case cRRechts                    ' --- Motor Rechtslauf
    MotorStatus = MotorStatus Or MotorRechts(MotorNr)
  Case cRAus                       ' --- Motor aus (schon oben gesetzt)
  Case Else
    MotorStatus = 0
  End Select
  SetMotor = GetInputs()           ' --- Aktualisieren des MotorStatus
  
End Function

Public Function SetMotorList(Optional M1, Optional M2, Optional M3, Optional M4, Optional M5, Optional M6, Optional M7, Optional M8) As Integer
Attribute SetMotorList.VB_Description = "Steueren der Ausgnge 1-4 (Motor, Lampe ...) in einem Auftrag."

' --- Setzen ausgewhlter Motoren ---

Dim StatusWord%

  StatusWord = MotorStatus
  If Not IsMissing(M1) Then StatusWord = SetStatus(StatusWord, 1, (M1))
  If Not IsMissing(M2) Then StatusWord = SetStatus(StatusWord, 2, (M2))
  If Not IsMissing(M3) Then StatusWord = SetStatus(StatusWord, 3, (M3))
  If Not IsMissing(M4) Then StatusWord = SetStatus(StatusWord, 4, (M4))
  If Not IsMissing(M5) Then StatusWord = SetStatus(StatusWord, 5, (M5))
  If Not IsMissing(M6) Then StatusWord = SetStatus(StatusWord, 6, (M6))
  If Not IsMissing(M7) Then StatusWord = SetStatus(StatusWord, 7, (M7))
  If Not IsMissing(M8) Then StatusWord = SetStatus(StatusWord, 8, (M8))
  MotorStatus = StatusWord
  
  SetMotorList = GetInputs()
  
End Function


Public Function SetMotors(ByVal StatusWord%) As Integer
Attribute SetMotors.VB_Description = "Schaltet alle Ausgnge gleichzeitig"

' --- Schalten aller Motoren gleichzeitig nach StatusWord ---

  MotorStatus = StatusWord
  SetMotors = GetInputs()
  
End Function


Private Function SetStatus(StatusWord%, MotorNr%, Direction%) As Integer

' --- Setzen des MotorStatus in StatusWord, kein Schalten des Motors ---

Dim s%

  s = StatusWord And MotorAus(MotorNr)
  Select Case Direction
  Case cRLinks
    s = s Or MotorLinks(MotorNr)
  Case cRRechts
    s = s Or MotorRechts(MotorNr)
  Case cRAus
  Case Else
    s = 0
  End Select
  
  SetStatus = s
  
End Function

Public Sub ShowPanel(Optional ByVal Links, Optional ByVal Oben)

' --- Anzeige des Interface Panels ----

  If IsMissing(Links) Then Links = 300
  If IsMissing(Oben) Then Oben = 300
  AnzeigePanel = True
  frmFishFace.ShowMe Me, (Links), (Oben)
  
End Sub


Public Property Get StatusAnalog(ByVal Nr%) As Integer
Attribute StatusAnalog.VB_Description = "Lesen des zuletzt festgestellten Werts eines Analogeinganges"

' --- Lesen des zuletzt festgestellten AnalogwertesX/Y ---
'     aus dem internen Statuswort
  
  StatusAnalog = AnalogXY(Nr)
  
End Property


Public Property Get StatusInputs() As Integer
Attribute StatusInputs.VB_Description = "Lesen des zuletzt festgestellten Status aller Eingnge aus dem internen StatusWort"

' --- Lesen des zuletzt festgestellten Status aller Eingnge ---
'     aus dem internen Statusword

  StatusInputs = InputStatus
  
End Property


Public Property Get StatusOutputs() As Integer
Attribute StatusOutputs.VB_Description = "Lesen des zuletzt festgestellten Status aller Ausgnge aus dem internen Statuswort."

' --- Lesen des zuletzt festgestellten Status aller Ausgnge ---
'     aus dem internen Statusword

  StatusOutputs = MotorStatus
  
End Property

Public Sub UnloadPanel()
Attribute UnloadPanel.VB_Description = "Lschen der Anzeige des Fischertechnik Interface Panels"

' --- Entladen des Interface Panels ---

  AnzeigePanel = False
  Unload frmFishFace
  
End Sub

Public Property Get Version() As String
Attribute Version.VB_Description = "Lesen der eigenen Versionsbezeichnung"

' --- Ausgabe der eigenen Versionsbezeichnung ---
'     1 = P|S         : Parallel/Seriell
'     2 = V|D         : Visual Basic/Delphi
'     3 = 1|2|3|4|5|6 : Sprachversion
'     4 = 16|32       : Wortbreite
'     6 = 130|311     : FishFace-Version

#If VBVersion = 532 Then
  If Left(ComName, 3) = "COM" Then Version = "SV532311" Else Version = "PV532311"
#End If
#If VBVersion = 432 Then
  If Left(ComName, 3) = "COM" Then Version = "SV432311" Else Version = "PV432311"
#End If
#If VBVersion = 416 Then
  If Left(ComName, 3) = "COM" Then Version = "SV416310" Else Version = "PV416310"
#End If

End Property

Public Function WaitForChange(ByVal InputNr%, Optional ByVal NrOfChanges, Optional ByVal TermInputNr) As Integer

' --- Warten auf eine oder mehrere (NrOfChanges) nderungen des Status
'     des Einganges InputNr oder TermInputNr = True

Dim i%, res%, res1 As Boolean, res2 As Boolean, M2%, M3%

  If IsMissing(NrOfChanges) Then NrOfChanges = 1
  
  res1 = GetInput(InputNr)
  M2 = EingabeMaske(InputNr)
  If IsMissing(TermInputNr) Then
    M3 = 0
  Else
    M3 = EingabeMaske(TermInputNr)
    res = GetInputs()
    If res And M3 Then                  ' --- TermInput bereits True
      WaitForChange = res
      Exit Function
    End If
  End If
  
  For i = 1 To NrOfChanges
    AbbruchZeit = GetTickCount() + AbbruchDelta
    Do
      res = GetInputs()
      If res = ftiDFehler Then Exit For ' --- Fehler ---
      If bNotHalt Or GetTickCount() > AbbruchZeit Then
        res = ftiFehler
        Exit For
      End If
      If res And M3 Then Exit For       ' --- TermInput : True ---
      res2 = res And M2                 ' --- Wert InputNr
    Loop While res1 = res2              ' --- Warten auf nderung
    res1 = res2                         ' --- neuer Vergleichswert
#If VBVersion = 532 Then
    If MitEvents Then RaiseEvent InputImpuls(InputNr, i)  ' --- Ereignis : Wechsel bei InputNr
#End If
  Next i
  
  WaitForChange = res
  
End Function

Public Function WaitForLow(ByVal InputNr%) As Integer
Attribute WaitForLow.VB_Description = "Warten auf eine True/False-Durchgang eines angebbaren Einganges."

' --- Warten auf einen true/false Druchgang von InputNr ---

Dim res%, res1 As Boolean, res2 As Boolean, M2%

  res1 = GetInput(InputNr)
  M2 = EingabeMaske(InputNr)
  
  If Not res1 Then                ' --- InputNr = True herstellen
    Do
      res = GetInputs()
      If res = ftiDFehler Then Exit Do    ' --- Fehler ---
      If bNotHalt Then
        res = ftiFehler
        Exit Do
      End If
      res2 = res And M2
    Loop Until res2
  End If
  
  Do                             ' --- Wechsel auf False abwarten
    res = GetInputs()
    If res = ftiDFehler Then Exit Do
    If bNotHalt Then
      res = ftiFehler
      Exit Do
    End If
    res2 = res And M2
  Loop While res2
  
  WaitForLow = res

End Function

Public Sub WaitForTime(ByVal mSec&)
Attribute WaitForTime.VB_Description = "Anhalten des Programmablaufs um mSec MilliSekunden"

' --- Anhalten des Programmablaufs um mSec MilliSekunden ---

Dim sZeit&, res%

  sZeit = GetTickCount()
  Do
    DoEvents
    res = GetInputs()
  Loop Until (GetTickCount() - sZeit) > mSec Or bNotHalt

End Sub

Private Sub Class_Initialize()

  Set MotCntl = New clsMotorListe
  InitWerte
  
End Sub


Private Sub Class_Terminate()

  CloseInterface

End Sub


Public Property Get ReadIntervalTimeout() As Long
Attribute ReadIntervalTimeout.VB_Description = "Maximale Zeit zwischen dem Eintreffen von zwei Bytes in ms"

#If Win32 Then
  ReadIntervalTimeout = comITimeOuts.ReadIntervalTimeout
#Else
  ReadIntervalTimeout = 0
#End If
  
End Property

Public Property Let ReadIntervalTimeout(ByVal vMilliSec&)

#If Win32 Then
  comITimeOuts.ReadIntervalTimeout = vMilliSec
#End If
  
End Property

Public Property Get ReadTotalTimeoutMultiplier() As Long
Attribute ReadTotalTimeoutMultiplier.VB_Description = "Timeoutzeit fr das Lesen eines Bytes, wird mit der Anzahl der zu lesenden Bytes multipliziert."

#If Win32 Then
  ReadTotalTimeoutMultiplier = comITimeOuts.ReadTotalTimeOutConstant
#Else
  ReadTotalTimeoutMultiplier = 0
#End If
  
End Property

Public Property Let ReadTotalTimeoutMultiplier(ByVal vMilliSec&)

#If Win32 Then
  comITimeOuts.ReadTotalTimeOutConstant = vMilliSec
#End If
  
End Property

Public Property Get ReadTotalTimeOutConstant() As Long
Attribute ReadTotalTimeOutConstant.VB_Description = "Basis Timeoutzeit fr das Lesen"

#If Win32 Then
  ReadTotalTimeOutConstant = comITimeOuts.ReadTotalTimeoutMultiplier
#Else
  ReadTotalTimeOutConstant = 0
#End If
  
End Property

Public Property Let ReadTotalTimeOutConstant(ByVal vMilliSec&)

#If Win32 Then
  comITimeOuts.ReadTotalTimeoutMultiplier = vMilliSec
#End If
  
End Property

Public Property Get WriteTotalTimeoutMultiplier() As Long
Attribute WriteTotalTimeoutMultiplier.VB_Description = "Timeoutzeit fr das Schreiben eines Bytes in Millisekunden, wird mit der Anzahl der zu schreibenden Bytes multipliziert."

#If Win32 Then
  WriteTotalTimeoutMultiplier = comITimeOuts.WriteTotalTimeoutConstant
#Else
  WriteTotalTimeoutMultiplier = 0
#End If
  
End Property

Public Property Let WriteTotalTimeoutMultiplier(ByVal vMilliSec&)

#If Win32 Then
  comITimeOuts.WriteTotalTimeoutConstant = vMilliSec
#End If

End Property

Public Property Get WriteTotalTimeoutConstant() As Long
Attribute WriteTotalTimeoutConstant.VB_Description = "Basis Timeoutzeit fr das Schreiben"

#If Win32 Then
  WriteTotalTimeoutConstant = comITimeOuts.WriteTotalTimeoutMultiplier
#Else
  WriteTotalTimeoutConstant = 0
#End If
  
End Property

Public Property Let WriteTotalTimeoutConstant(ByVal vMilliSec&)

#If Win32 Then
  comITimeOuts.WriteTotalTimeoutMultiplier = vMilliSec
#End If
  
End Property
