VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsMotorListe"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' -----------------------------------------------------------------------
'
' clsMotorListe(MotListe.CLS)                       Ulrich Mller 28.3.99
'                                                    Del XPS P90    VB5/6
' Liste von simultan zu steuernden Motoren
'
' -----------------------------------------------------------------------

Option Explicit

Private Type Mot
  Name As String
  Nr As Integer
  Impuls As Integer
  Ende As Integer
  EndPosition As Integer
  Position As Integer
End Type

Private MotorTab(0 To 7) As Mot ' --- Motortabelle
                                '     (Ende : Motor rechtsdrehend)

Public Property Let Ende(i%, Nr%)
Attribute Ende.VB_Description = "Motorliste : zugehrender EndeEingang (Motor rechtsdrehend)"

' --- Motorliste : zugehrender EndeEingang  ---
'                  Motor rechtsdrehend : positiv
'                        linksdrehend  : negativ

  MotorTab(i - 1).Ende = Nr
  
End Property

Public Property Get Ende(i%) As Integer

' --- Motorliste : zugehrender EndeEingang  ---
'                  Motor rechtsdrehend : positiv
'                        linksdrehend  : negativ

  Ende = MotorTab(i - 1).Ende
  
End Property

Public Property Let EndPosition(i%, EP%)

' --- Motorliste : zulssige Endposition ---
'                  entgegengesetzte Fahrichtung zu Ende
                   
  MotorTab(i - 1).EndPosition = EP
  
End Property

Public Property Get EndPosition(i%) As Integer

' --- Motorliste : zulssige Endposition ---
'                  entgegengesetzte Fahrichtung zu Ende

  EndPosition = MotorTab(i - 1).EndPosition
  
End Property

Public Property Let Impuls(i%, Ei%)
Attribute Impuls.VB_Description = "Motorliste : zugehrender Impulseingang"

' --- Motorliste : zugehrender Impulseingang ---

  MotorTab(i - 1).Impuls = Ei
  
End Property

Public Property Get Impuls(i%) As Integer

' --- Motorliste : zugehrender Impulseingang ---

  Impuls = MotorTab(i - 1).Impuls
  
End Property

Public Property Get Name(i%) As String
Attribute Name.VB_Description = "Motorliste : Name des Motors"

' --- Motorliste : Name des Motors ---

  Name = MotorTab(i - 1).Name
  
End Property

Public Property Let Name(i%, n$)

  MotorTab(i - 1).Name = n
  
End Property

Public Property Let Nr(i%, Nr%)
Attribute Nr.VB_Description = "Motorliste : MotorNr auf Position i "

' --- Motorliste : MotorNr auf Position i ---

  MotorTab(i - 1).Nr = Nr
  
End Property


Public Property Get Nr(i%) As Integer

' --- Motorliste : MotorNr auf Position i ---

  Nr = MotorTab(i - 1).Nr
  
End Property

Public Property Let Position(i%, Posi%)
Attribute Position.VB_Description = "Motorliste : zugehrende Position "

' --- Motorliste : zugehrende Position ---

  MotorTab(i - 1).Position = Posi
  
End Property

Public Property Get Position(i%) As Integer

' --- Motorliste : zugehrende Position ---

  Position = MotorTab(i - 1).Position
  
End Property

Private Sub Class_Initialize()

Dim i%

  For i = 0 To 7
    MotorTab(i).Name = "Dummy"
    MotorTab(i).Nr = i + 1
    MotorTab(i).Impuls = i * 2 + 1
    MotorTab(i).Ende = i * 2 + 2
    MotorTab(i).EndPosition = 9999
    MotorTab(i).Position = 9999
  Next i

End Sub
