Attribute VB_Name = "basRobot91Teach"
' -------------------------------------------------------------------------
'
'  basRobot91Teach(Robo91TX.BAS)                      Ulrich Mller  1.6.98
'                                                     Dell XPS P90      VB5
'  Fischertechnik Profi-Robotor 91 : Public Variable
'      Public Routinen, Roboter-Programme
'  PORTNR = 1 (siehe Interface Konstanten)
'
' Die wesentlichen Betriebsprogramme sind :
'
' - Bringe            : Gegriffenes Teil auf vorgegebene Position bringen                  bringen
' - GreiferAuf        : ffnen des Greifer bis zum Anschlag
' - GreiferZu         : Schlieen des Greifers auf "Verdacht" : Anzahl
'                       Impulse
' - Heben             : Armheben bis zur Endlage
' - Hole              : Teil auf vorgegebener Postion greifen
' - InitM             : Fahren auf Ausgangsposition
' - PosV6             : Turm auf vorgegebene Position drehen
' - RobotDemo         : Demo Programm fr Robot91 : einfacher
'                       Bewegungszyklus Hole - Bringe nach Profi-Robot
' - Senken            : Senken des Arm auf "Verdacht" : Anzahl Impulse
'
' Die ursprnglich fr Robot91 konzipierten Programme werden mit RobotDemo
' weiter genutzt, entsprechen aber nicht dem restlichen Konzept
' InitM ist als "sichere" Methode zum Anfahren der Grundstellung eine
' Ausnahme
'
' -------------------------------------------------------------------------

Option Explicit

' --- Interface Konstanten ---

Public Const cComNr = 1             ' Nr des COM/LPT-Ports
Public Const cRLinks = 1            ' Motor nomineller Linkslauf
Public Const cRRechts = 2           ' Motor nomineller Rechtslauf
Public Const cRAus = 0              ' Motor Abschalten
Public Const cRReset = 8            ' Reset-Eingang
Public Const cRNotHalt = 8          ' NotHalt-Eingang
Public Const cRMaskeEingnge = &H3F ' Maskierung der Motoreingnge

' --- Farbcodierung ---

Public Const cFarbeAus = &H8000000F
Public Const cFarbeAusH = &HE0E0E0
Public Const cFarbeEin = &HFF00&
Public Const cFarbeFehler = &HFF8&
Public Const cFarbeEnde = &H80C0FF

' --- Turm ---

Public Const cRTurmMotor = 1, cRTurmMoMaske = &H3
Public Const cRTurmRechts = cRRechts
Public Const cRTurmLinks = cRLinks, cRTurmLiMaske = &H1
Public Const cRTurmEnde = 6, cRTurmEmaske = &H20
Public Const cRTurmImpuls = 2, cRTurmImaske = &H2

' --- Arm ---

Public Const cRArmMotor = 2, cRArmMoMaske = &HC
Public Const cRArmAuf = cRRechts
Public Const cRArmAb = cRLinks, cRArmAbMaske = &H4
Public Const cRArmEnde = 3, cRArmEmaske = &H4
Public Const cRArmImpuls = 5, cRArmImaske = &H10

' --- Greifer ---

Public Const cRGreiferMotor = 3, cRGreiferMoMaske = &H30
Public Const cRGreiferAuf = cRRechts
Public Const cRGreiferZu = cRLinks, cRGreiferZuMaske = &H10
Public Const cRGreiferEnde = 1, cRGreiferEmaske = &H1
Public Const cRGreiferImpuls = 4, cRGreiferImaske = 8

' --- Public Variable ---

Public ft As clsFishFace             ' --- Kurzschreibweise zum Ansprechen
                                     '     von Funktionen des FishFace
Public mf As frmRobotMain            ' --- Kurzschreibweise fr RobotMain
Public ProgrammNr%                   ' Nr des akt. laufenden Programms
' ----- Positionen : Zhlung erfolgt in den entsprechenden Programmen
'       bei Stellbewegungen ber das Display wird ggf. 'steht' angezeigt
Public TurmPosition%                 ' Turmposition in Anzahl Impulsen
                                     ' Position Rechts = 0
Public ArmPosition%                  ' Armposition in Anzahl Impulsen
                                     ' Position Oben = 0
Public GreiferPosition%              ' Greiferposition in Anzahl Impulsen
                                     ' Position Offen = 0

' --- Programmdaten ---

Public Takt(0 To 100, 0 To 2) ' Daten aktuelles Betriebsprogramm
Public aktStep%, anzTakte%    ' aktueller Schritt, Anzahl Takte + 1
Public TaktFile$              ' aktuelles Scriptfile (Pfadname)
Public TaktTitel$             ' Filename pur
Public GreiferImpulseD%       ' Anzahl Schlieimpulse
Public GreiferHheD%          ' Anzahl Senkenimpulse
Public HolePositionD%         ' Anzahl Impulse von rechts zur HolePosition
Public BringePositionD%       ' Anzahl Impulse von rechts zur BringePosition
Public WiederholenD As Boolean  ' Wiederholen des Ablaufzyklus


Private Sub Bringe(PosW%)

' --- Gegriffenes Teil auf vorgegebene Position (PosV6) bringen ---

  If ft.GetInput(cRGreiferEnde) Then
    Exit Sub
  Else
    PosV6 PosW
    Senken GreiferHheD
    GreiferAuf
    Heben
  End If
  
End Sub


Private Sub GreiferAuf()

' --- ffnen des Greifer bis zum Anschlag ---
    
  If Not ft.GetInput(cRGreiferEnde) Then
    mf!lblGAction = "ffnet"
    mf!lblGAction.BackColor = cFarbeEin
    ft.SetMotor cRGreiferMotor, cRGreiferAuf
    Do
    Loop Until ft.GetInput(cRGreiferEnde)
    ft.SetMotor cRGreiferMotor, cRAus
    mf!lblGAction = "offen"
    mf!lblGAction.BackColor = cFarbeEnde
    GreiferPosition = 0
  End If
  
End Sub

Private Sub GreiferZu(GZu%)

' --- Schlieen des Greifers auf "Verdacht" : Anzahl Impulse cRGreiferSCnt

  mf!lblGAction = "schliet"
  mf!lblGAction.BackColor = cFarbeEin
  ft.SetMotor cRGreiferMotor, cRGreiferZu
  ft.WaitForChange cRGreiferImpuls, GZu
  ft.SetMotor cRGreiferMotor, cRAus
  GreiferPosition = GreiferPosition + GZu
  mf!lblGAction = Format(GreiferPosition, "000")
  mf!lblGAction.BackColor = cFarbeAusH
  
End Sub

Private Sub Heben()

' --- Armheben bis zur Endlage ---
  
  If Not ft.GetInput(cRArmEnde) Then
    mf!lblAAction = "hebt"
    mf!lblAAction.BackColor = cFarbeEin
    ft.SetMotor cRArmMotor, cRArmAuf
    Do
    Loop Until ft.GetInput(cRArmEnde)
    ft.SetMotor cRArmMotor, cRAus
    mf!lblAAction = "oben"
    mf!lblAAction.BackColor = cFarbeEnde
    ArmPosition = 0
  End If
  
End Sub

Private Sub Hole(PosW%)

' --- Teil auf vorgegebener Position greifen ---

  If ft.GetInput(cRGreiferEnde) Then
    PosV6 PosW
    Senken GreiferHheD
    GreiferZu GreiferImpulseD
    Heben
  Else
    mf!lblStatus = "Holen is nich"
    Exit Sub
  End If
  
End Sub


Public Sub InitM()

' --- Robot91 : Fahren auf Ausgangsposition ---
    
  mf!lblStatus = "Fhrt auf Grundstellung"
  mf!lblStatus.BackColor = cFarbeEin
  mf!cmdStartR.Caption = "HALT"                ' --- Sperre Programmaufruf
  
  ft.NotHalt = False
  Heben
  mf!lblAAction.BackColor = cFarbeEnde
  mf!lblAAction = "oben"
  ArmPosition = 0
  
  GreiferAuf
  mf!lblGAction = "offen"
  mf!lblGAction.BackColor = cFarbeEnde
  GreiferPosition = 0
  
  mf!lblTAction = "rechts"
  mf!lblTAction.BackColor = cFarbeEnde
  TurmPosition = 0
  
  If Not ft.GetInput(cRTurmEnde) Then
    ft.SetMotor cRTurmMotor, cRTurmRechts
    Do
    Loop Until ft.GetInput(cRTurmEnde)
    ft.SetMotor cRTurmMotor, cRAus
  End If
  
  ft.MotCntl.Name(1) = "Turm"
  ft.MotCntl.nr(1) = cRTurmMotor
  ft.MotCntl.Impuls(1) = cRTurmImpuls
  ft.MotCntl.Ende(1) = cRTurmEnde
  ft.MotCntl.Position(1) = 0
  
  ft.MotCntl.Name(2) = "Arm"
  ft.MotCntl.nr(2) = cRArmMotor
  ft.MotCntl.Impuls(2) = cRArmImpuls
  ft.MotCntl.Ende(2) = cRArmEnde
  ft.MotCntl.Position(2) = 0
  
  ft.MotCntl.Name(3) = "Greifer"
  ft.MotCntl.nr(3) = cRGreiferMotor
  ft.MotCntl.Impuls(3) = cRGreiferImpuls
  ft.MotCntl.Ende(3) = cRGreiferEnde
  ft.MotCntl.Position(3) = 0
  
  mf!lblStatus = "Auf Grundstellung"
  mf!lblStatus.BackColor = cFarbeEnde
  mf!cmdStartR.Caption = "START"          ' --- Sperre aufheben
  
End Sub

Private Sub PosV6(PosW%)

' --- Turm auf vorgegebene Position drehen ---

  mf!lblTAction = "dreht"
  mf!lblTAction.BackColor = cFarbeEin
  If PosW < TurmPosition Then
    ft.SetMotor cRTurmMotor, cRTurmRechts
    ft.WaitForChange cRTurmImpuls, TurmPosition - PosW, cRTurmEnde
  Else
    ft.SetMotor cRTurmMotor, cRTurmLinks
    ft.WaitForChange cRTurmImpuls, PosW - TurmPosition
  End If
  TurmPosition = PosW
  ft.SetMotor cRTurmMotor, cRAus
  mf!lblTAction = Format(TurmPosition, "000")
  mf!lblTAction.BackColor = cFarbeAusH
  
End Sub


Public Sub RobotDemo()

' --- Demo Programm fr Robot91 : einfacher Bewegungszyklus Hole - Bringe
'     nach Profi-Robot
  
  mf!lblStatus = "Robot91 Demo luft"
  mf!lblStatus.BackColor = cFarbeEin
  Do
    Hole HolePositionD
    Bringe BringePositionD
  Loop While WiederholenD
  
  ft.ClearMotors
  mf!lblStatus.BackColor = cFarbeEnde
  mf!lblStatus = "Robot91 Demo beendet"
  
End Sub

Private Sub Senken(Aab%)

' --- Senken des Arm auf "Verdacht" : Anzahl Impulse cRArmSCnt ---

  mf!lblAAction = "senkt"
  mf!lblAAction.BackColor = cFarbeEin
  ft.SetMotor cRArmMotor, cRArmAb
  ft.WaitForChange cRArmImpuls, Aab
  ft.SetMotor cRArmMotor, cRAus
  ArmPosition = ArmPosition + Aab
  mf!lblAAction = Format(ArmPosition, "000")
  mf!lblAAction.BackColor = cFarbeAusH
  
End Sub


